# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Migrate::Mgmt::V2018_02_02
  module Models
    #
    # A network adapter assessed for an assessment.
    #
    class AssessedNetworkAdapter

      include MsRestAzure

      # @return [String] MAC Address of the network adapter.
      attr_accessor :mac_address

      # @return [Array<String>] List of IP Addresses on the network adapter.
      attr_accessor :ip_addresses

      # @return [Float] Monthly cost estimate for network bandwidth used by
      # this network adapter.
      attr_accessor :monthly_bandwidth_costs

      # @return [Float] Adapter throughput for incoming traffic in MegaBytes
      # per second.
      attr_accessor :megabytes_per_second_received

      # @return [Integer] Expected data points for incoming traffic in
      # MegaBytes per second.
      attr_accessor :megabytes_per_second_received_data_points_expected

      # @return [Integer] Received data points for incoming traffic in
      # MegaBytes per second.
      attr_accessor :megabytes_per_second_of_read_data_points_received

      # @return [Float] Adapter throughput for outgoing traffic in MegaBytes
      # per second.
      attr_accessor :megabytes_per_second_transmitted

      # @return [Integer] Expected data points for outgoing traffic in
      # MegaBytes per second.
      attr_accessor :megabytes_per_second_transmitted_data_points_expected

      # @return [Integer] Received data points for outgoing traffic in
      # MegaBytes per second.
      attr_accessor :megabytes_per_second_transmitted_data_points_received

      # @return [Float] Gigabytes transmitted through this adapter each month.
      attr_accessor :net_gigabytes_transmitted_per_month

      # @return [CloudSuitability] Whether this adapter is suitable for Azure.
      # Possible values include: 'Unknown', 'NotSuitable', 'Suitable',
      # 'ConditionallySuitable', 'ReadinessUnknown'
      attr_accessor :suitability

      # @return [AzureNetworkAdapterSuitabilityExplanation] If network adapter
      # is suitable, this explains the reasons and mitigation steps. Possible
      # values include: 'Unknown', 'NotApplicable', 'InternalErrorOccured'
      attr_accessor :suitability_explanation


      #
      # Mapper for AssessedNetworkAdapter class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AssessedNetworkAdapter',
          type: {
            name: 'Composite',
            class_name: 'AssessedNetworkAdapter',
            model_properties: {
              mac_address: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'macAddress',
                type: {
                  name: 'String'
                }
              },
              ip_addresses: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'ipAddresses',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              monthly_bandwidth_costs: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'monthlyBandwidthCosts',
                type: {
                  name: 'Double'
                }
              },
              megabytes_per_second_received: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'megabytesPerSecondReceived',
                type: {
                  name: 'Double'
                }
              },
              megabytes_per_second_received_data_points_expected: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'megabytesPerSecondReceivedDataPointsExpected',
                type: {
                  name: 'Number'
                }
              },
              megabytes_per_second_of_read_data_points_received: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'megabytesPerSecondOfReadDataPointsReceived',
                type: {
                  name: 'Number'
                }
              },
              megabytes_per_second_transmitted: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'megabytesPerSecondTransmitted',
                type: {
                  name: 'Double'
                }
              },
              megabytes_per_second_transmitted_data_points_expected: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'megabytesPerSecondTransmittedDataPointsExpected',
                type: {
                  name: 'Number'
                }
              },
              megabytes_per_second_transmitted_data_points_received: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'megabytesPerSecondTransmittedDataPointsReceived',
                type: {
                  name: 'Number'
                }
              },
              net_gigabytes_transmitted_per_month: {
                client_side_validation: true,
                required: false,
                serialized_name: 'netGigabytesTransmittedPerMonth',
                type: {
                  name: 'Double'
                }
              },
              suitability: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'suitability',
                type: {
                  name: 'String'
                }
              },
              suitability_explanation: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'suitabilityExplanation',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
