# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Migrate::Mgmt::V2018_02_02
  module Models
    #
    # Azure Migrate Project.
    #
    class Project

      include MsRestAzure

      # @return [String] Path reference to this project
      # /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Migrate/projects/{projectName}
      attr_accessor :id

      # @return [String] Name of the project.
      attr_accessor :name

      # @return [String] Type of the object = [Microsoft.Migrate/projects].
      attr_accessor :type

      # @return [String] For optimistic concurrency control.
      attr_accessor :e_tag

      # @return [String] Azure location in which project is created.
      attr_accessor :location

      # @return Tags provided by Azure Tagging service.
      attr_accessor :tags

      # @return [DateTime] Time when this project was created. Date-Time
      # represented in ISO-8601 format.
      attr_accessor :created_timestamp

      # @return [DateTime] Time when this project was last updated. Date-Time
      # represented in ISO-8601 format.
      attr_accessor :updated_timestamp

      # @return [DiscoveryStatus] Reports whether project is under discovery.
      # Possible values include: 'Unknown', 'NotStarted', 'InProgress',
      # 'Completed'
      attr_accessor :discovery_status

      # @return [String] ARM ID of the Service Map workspace created by user.
      attr_accessor :customer_workspace_id

      # @return [String] Location of the Service Map workspace created by user.
      attr_accessor :customer_workspace_location

      # @return [DateTime] Time when this project was created. Date-Time
      # represented in ISO-8601 format. This value will be null until discovery
      # is complete.
      attr_accessor :last_discovery_timestamp

      # @return [String] Session id of the last discovery.
      attr_accessor :last_discovery_session_id

      # @return [Integer] Number of groups created in the project.
      attr_accessor :number_of_groups

      # @return [Integer] Number of machines in the project.
      attr_accessor :number_of_machines

      # @return [Integer] Number of assessments created in the project.
      attr_accessor :number_of_assessments

      # @return [DateTime] Time when last assessment was created. Date-Time
      # represented in ISO-8601 format. This value will be null until
      # assessment is created.
      attr_accessor :last_assessment_timestamp

      # @return [ProvisioningState] Provisioning state of the project. Possible
      # values include: 'Accepted', 'Creating', 'Deleting', 'Failed', 'Moving',
      # 'Succeeded'
      attr_accessor :provisioning_state


      #
      # Mapper for Project class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Project',
          type: {
            name: 'Composite',
            class_name: 'Project',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              e_tag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eTag',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Object'
                }
              },
              created_timestamp: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              updated_timestamp: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.updatedTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              discovery_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.discoveryStatus',
                type: {
                  name: 'String'
                }
              },
              customer_workspace_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.customerWorkspaceId',
                type: {
                  name: 'String'
                }
              },
              customer_workspace_location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.customerWorkspaceLocation',
                type: {
                  name: 'String'
                }
              },
              last_discovery_timestamp: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastDiscoveryTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              last_discovery_session_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastDiscoverySessionId',
                type: {
                  name: 'String'
                }
              },
              number_of_groups: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.numberOfGroups',
                type: {
                  name: 'Number'
                }
              },
              number_of_machines: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.numberOfMachines',
                type: {
                  name: 'Number'
                }
              },
              number_of_assessments: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.numberOfAssessments',
                type: {
                  name: 'Number'
                }
              },
              last_assessment_timestamp: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastAssessmentTimestamp',
                type: {
                  name: 'DateTime'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
